unit selctMapTest;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, TeeProcs, TeeTree, TeeDBTre, StdCtrls, ComCtrls, Provider,
  DB, DBClient;

type
  TdbuType=(dbuParadox=0,                        //Paradox
            dbuACCESS97=1,                       //Access version 97
            dbuIB=2);                            //Interbase
  TdbuDBParams = record
    Path             : string;                   //Name and path, for IB this field is in special syntax
    UNCPath          : string;                   //UNC name and path of the database in UNC format
    dbuType          : TdbuType;                 //Database type - this type determines the format of Path
    LoginPrompt      : boolean;                  //Show a login prompt use supplied UserName and Password
    UserName         : string;                   //UserName
    Password         : string;                   //Password
    DatabaseName     : string;                   //Name of the database component
    ActiveDBEngineNo : Integer;                  //The choice of database engine; 0 = BDE, 1 = DBX, 2 = IBC..
  end;

  TForm12 = class(TForm)
    DBTree1: TDBTree;
    RichEdit1: TRichEdit;
    CDS: TClientDataSet;
    DataSetProvider1: TDataSetProvider;
    procedure FormCreate(Sender: TObject);
    procedure DBTree1ClickShape(Sender: TTreeNodeShape; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    function FindNode(Tree: TCustomTree; Tag: integer): TTreeNodeShape;
  public
    { Public declarations }
  end;

var
  Form12: TForm12;

implementation

{$R *.dfm}

procedure TForm12.FormCreate(Sender: TObject);
var
  NewShape      : TTreeNodeShape;
  Workspace     : Integer;
begin
  CDS.LoadFromFile( ExtractFilePath( Application.ExeName ) + 'Workspacetbl.xml' );
  DBTree1.DataSet := CDS as Tdataset;
  DBTree1.Refresh;
  while not CDS.EOF do begin                             //Loop through the Query
    Workspace:=CDS.FieldByName('Workspace').AsInteger;
    //this is where we provoke the error: Expand all level 1 nodes and unexpand the rest.
    NewShape:=FindNode(DBTree1,Workspace);
    NewShape.Expanded := NewShape.Level=1;
    CDS.Next;
  end;
  MessageDlg('Error preparations completed: On our end, we have an invisible node overlapping the root node approx at the text field'
  + ' click to verify this', mtInformation, [mbOk], 0);
end;

function TForm12.FindNode(Tree: TCustomTree; Tag: integer): TTreeNodeShape;

var
  I             : integer;
  NS            : integer;
  NewShape      : TTreeNodeShape;
begin
  I:=0;
  NS:=Tree.Shapes.Count;
  Result:=nil;
  while (Result=nil) and (I<=NS-1) do begin  //Look through all the nodes
    if Tree.Shapes[I] is TTreeNodeShape then begin
      NewShape:=Tree.Shapes[I] as TTreeNodeShape;
      if NewShape.Tag=Tag then Result:=NewShape;           //See if the tags matchs
    end;
    inc(I);
  end;
end;
//*****************************************************************************


procedure TForm12.DBTree1ClickShape(Sender: TTreeNodeShape;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  RichEdit1.Clear;
  RichEdit1.Lines.Add('Tag:'+InttoStr(Sender.tag));
  RichEdit1.Lines.Add('Top:'+InttoStr(Sender.top));
  RichEdit1.Lines.Add('Left:'+InttoStr(Sender.left));
  RichEdit1.Lines.Add('Height:'+InttoStr(Sender.height));
  RichEdit1.Lines.Add('Width:'+InttoStr(Sender.width));
  RichEdit1.Lines.Add('Text:' + Sender.Text[0]);

end;

end.
